﻿using UnityEngine;
using System.Collections;

//Creamos un tipo enumerado para definir la dirección
public enum Direccion { Horizontal, Vertical }

public class scriptDisparo : MonoBehaviour
{
    //Variables públicas
    private SpriteRenderer spriteImage;
    public Sprite spriteImage1;
    public Sprite spriteImage2;
    public Sprite spriteImage3;


    public Direccion DireccionArma = Direccion.Vertical;
    public float Velocidad = 50.0F;

    //Variables privadas
    private Rigidbody2D thisRigidbody;
    //private Sprite = disparoizq;

    void Start()
    {
        thisRigidbody = GetComponent<Rigidbody2D>();
        spriteImage = GetComponent<SpriteRenderer>();
        if (spriteImage.sprite == null) // if the sprite on spriteRenderer is null then
            spriteImage.sprite = spriteImage1;
    }

    void Update()
    {
        //Establecemos su velocidad y su dirección
        if (DireccionArma == Direccion.Horizontal)
        {
            //Movemos el arma en horizontal
            thisRigidbody.transform.Translate(new Vector2(Velocidad, 0) * Time.deltaTime);
            //
            if (Velocidad < 0 && spriteImage.sprite != spriteImage1)
            {
                spriteImage.sprite = spriteImage1;
            }
            else if (Velocidad > 0 && spriteImage.sprite != spriteImage2)
            {
                spriteImage.sprite = spriteImage2;
            }
        }
        else
        {
            //Movemos el arma en vertical
            thisRigidbody.transform.Translate(new Vector2(0, Velocidad) * Time.deltaTime);
            
            if (spriteImage.sprite != spriteImage3)
            {
                spriteImage.sprite = spriteImage3;
            }
        }
    }

    /*void OnCollisionEnter2D(Collision2D other)
    {
        scriptEnemigo enemigo = other.gameObject.GetComponent<scriptEnemigo>();
        if (enemigo.tag == "Enemigo")
        {
            //Si el ataque colisiona contra un objeto con el tag 'Enemigo', se decrementan las vidas de dicho enemigo
            other.gameObject.GetComponent<scriptEnemigo>().vida--;

            //Destruimos el objeto cuando colisione contra un enemigo
            Destroy(gameObject);
        }
    }
    */

    void OnBecameInvisible()
    {
        //Destruimos el objeto padre cuando salga fuera de la pantalla
        enabled = false;
        Destroy(gameObject);
    }
}